module Feature.Sharing.HTTP ( routes ) where

import Core.Types
import Core.Templates (renderIndex)

import Feature.Sharing.Templates (renderPw)
import Feature.Sharing.Couch     (findByLink, findToSecret)

import qualified Data.Text      as T
import qualified Data.Text.Lazy as LT

import Control.Monad.Reader (ask, lift)
import Web.Scotty.Trans 
import Prelude 

routes :: PurrApp ()
routes = do 

  get "/pw/:id" $ do
    reqId     <- param "id"
    secretRes <- findByLink reqId
    html       $ renderIndex reqId (findToSecret secretRes)

  post "/pw" $ do
    reqId     <- param "userLink"
    secretRes <- findByLink reqId
    html       $ renderPw reqId (findToSecret secretRes)
