module Feature.Sharing.Types where

import Data.Aeson
import Data.Map.Strict (Map)
import Data.Typeable   (Typeable)
import GHC.Generics

data SecretEntry = SecretEntry
   { _id          :: Maybe String
   , _rev         :: Maybe String
   , creationTime :: String
   , link         :: String
   , secret       :: String
   } deriving (Generic, Show, Typeable)

data FindResults = FindResults
  { bookmark :: String
  , docs     :: [SecretEntry]
  , warning  :: Maybe String
  } deriving (Generic, Show, Typeable)

instance ToJSON SecretEntry where
  toEncoding = genericToEncoding defaultOptions
instance ToJSON FindResults where
  toEncoding = genericToEncoding defaultOptions

instance FromJSON SecretEntry
instance FromJSON FindResults
